Codeforces 852D Exploration plan(最短路+二分+二分图匹配)

来源:互联网 发布:淘宝琴行哪个好 编辑:程序博客网 时间:2024/06/07 13:46
D. Exploration plan
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

The competitors of Bubble Cup X gathered after the competition and discussed what is the best way to get to know the host country and its cities.

After exploring the map of Serbia for a while, the competitors came up with the following facts: the country has V cities which are indexed with numbers from 1 to V, and there are E bi-directional roads that connect the cites. Each road has a weight (the time needed to cross that road). There are N teams at the Bubble Cup and the competitors came up with the following plan: each of the N teams will start their journey in one of the V cities, and some of the teams share the starting position.

They want to find the shortest time T, such that every team can move in these T minutes, and the number of different cities they end up in is at least K (because they will only get to know the cities they end up in). A team doesn't have to be on the move all the time, if they like it in a particular city, they can stay there and wait for the time to pass.

Please help the competitors to determine the shortest time T so it's possible for them to end up in at least K different cities or print -1 if that is impossible no matter how they move.

Note that there can exist multiple roads between some cities.

Input

The first line contains four integers: VEN and K (1 ≤  V  ≤  600,  1  ≤  E  ≤  20000,  1  ≤  N  ≤  min(V, 200),  1  ≤  K  ≤  N), number of cities, number of roads, number of teams and the smallest number of different cities they need to end up in, respectively.

The second line contains N integers, the cities where the teams start their journey.

Next E lines contain information about the roads in following format: Ai Bi Ti (1 ≤ Ai, Bi ≤ V,  1 ≤ Ti ≤ 10000), which means that there is a road connecting cities Ai and Bi, and you need Ti minutes to cross that road.

Output

Output a single integer that represents the minimal time the teams can move for, such that they end up in at least K different cities or output -1 if there is no solution.

If the solution exists, result will be no greater than 1731311.

Example
input
6 7 5 45 5 2 2 51 3 31 5 21 6 52 5 42 6 73 4 113 5 3
output
3
Note

Three teams start from city 5, and two teams start from city 2. If they agree to move for 3 minutes, one possible situation would be the following: Two teams in city 2, one team in city 5, one team in city 3 , and one team in city 1. And we see that there are four different cities the teams end their journey at.


题意:有V个点,N个队伍,E条边,经过每条边有个时间,告诉你初始N个队伍的位置,求至少有K个队伍在不同的点的最短时间
题解:求出N个队伍所在的点到其他所有点的最短时间,然后二分答案,每次二分图匹配看是否满足要求
代码:
#include<stdio.h>#include<algorithm>#include<string.h>#include<queue>#define V 605#define N 202#define P pair<int,int>using namespace std;typedef long long ll;const int inf=1731312;struct node{    int v,next,c;}eg[20005*2];int head[V],tot,p[N],ji[V],d[V][V],v,match[V],n;bool a[V][V];void add(int x,int y,int c){    eg[tot]=node{y,head[x],c};    head[x]=tot++;}void dist(int src){    priority_queue<P,vector<P>,greater<P> >Q;    Q.push(P(0,src));    while(!Q.empty())    {        int p=Q.top().second;        int dis=Q.top().first;        Q.pop();        if(d[src][p]<dis)continue;        d[src][p]=dis;        for(int i=head[p];~i;i=eg[i].next)        {            int v=eg[i].v;            if(d[src][v]<dis+eg[i].c)continue;            d[src][v]=dis+eg[i].c;            Q.push(P(d[src][v],v));        }    }}bool dfs(int p){    for(int i=1;i<=v;i++)    {        if(ji[i]||!a[p][i])continue;        ji[i]=1;        if(match[i]==-1||dfs(match[i])){            match[i]=p;            return 1;        }    }    return 0;}int check(int x){    memset(match,-1,sizeof(match));    for(int i=1;i<=n;i++)        for(int j=1;j<=v;j++)            a[i][j]=d[p[i]][j]<=x;    int ans=0;    for(int i=1;i<=n;i++){        memset(ji,0,sizeof(ji));        if(dfs(i))ans++;    }    return ans;}int main (){    int e,k;    scanf("%d%d%d%d",&v,&e,&n,&k);    tot=0;    memset(head,-1,sizeof(head));    for(int i=1;i<=v;i++)        for(int j=1;j<=v;j++)            d[i][j]=inf;    for(int i=1;i<=n;i++)        scanf("%d",&p[i]);    for(int i=0;i<e;i++){        int x,y,z;        scanf("%d%d%d",&x,&y,&z);        add(x,y,z);        add(y,x,z);    }    for(int i=1;i<=n;i++){        if(!ji[p[i]]){            ji[p[i]]=1;            dist(p[i]);        }    }    int l=0,r=inf,ans=inf;    while(l<=r)    {        int mid=l+r>>1;        if(check(mid)>=k)ans=mid,r=mid-1;        else l=mid+1;    }    if(ans==inf)ans=-1;    printf("%d\n",ans);    return 0;}


阅读全文
0 0
原创粉丝点击